' OptusNet Usage Monitor v4.2
' Modified by teemac - Australia
' My plan starts on the 14th of the month and I think v4.1 calculated from 1st of the month
' I know nothing about scripting except what I needed to learn in the last 3 days to modify this
'
' (based on: OptusNet Usage Monitor v4.1)
' (Modified by Chucky2k)
'
' Original script written by dx and kop48.
' Version 3.0 and 3.1 by Written by RaveRod (raverod@mantrasoftware.net)
'
' History:
'	v1.0 : Original dx script.
'	v2.0b: Modified by kop48 to include average usage.
'	v3.0 : Modified by RaveRod to download page ONCE and then read all information from there.
'	       Added function to get the time that usage was last updated.
'	       Added function to calculate how much usage is left per day (based on the per month function of kop48).
'	v3.1 : Fixed month size check to read end date from Optus Usage file.
'	v4.0 : Modified by Chucky2k to handle new usage.txt layout from optus.
'	       copied existing fuctions to read the Offpeak Data 
'	       allowance and usage. Original function names remain unchanged so no Samurize Config file changes will be
'	       needed if you don't want to display Offpeak information. Just set the Usename and Password and your away.
'	v4.1 : Modified Peak Usage as per suggestion by Funkdafied in the forums. The script will now work properly if
'              you go past your monthly allowance. Also changed the Get_HTML function as per AdamC in the forums to fix
'              an issue with updating the usage file.
'	v4.2 : Added DaysSince (start of plan), DaysRemaining (calculate days left in plan), MBPerDayRemaining
'              (capacity left in plan).
'              Removed OffPeak functions (didn't need them), CalcDay & CalcUsage (didn't work for me - my plan starts 14th '              of the month)

' Configuration.
username = "teemac"
password = "xopekaga"

' Gets the current Peak OptusNet usage.
Function Get_Usage
	contents = Read_File()
	leftMark = instr(instr( contents, "usage=" ) + 1, contents, "usage=" ) 
	leftMark = leftMark +6
	rightMark = instr( leftMark, contents, "MB" )
	Get_Usage = trim(mid( contents, leftMark, (rightMark-leftMark)))
End Function

' Gets the current Peak plan size.
Function Get_PlanSize
	contents = Read_File()
	leftMark = instr( contents, "plan_limit=" ) 
	leftMark = leftMark +11
	rightMark = instr( leftMark, contents, "MB" )
	Get_PlanSize = trim(mid( contents, leftMark, (rightMark-leftMark)))
end function

' Gets the time when the usage was updated.
Function Get_Time
	contents = Read_File()

	leftMark = instr( contents, "last=" )
	leftMark = leftMark +5

	rightMark = instr( leftMark, contents, "-" )
	LastY = trim(mid( contents, leftMark+2, (rightMark-leftMark-2)))

	leftMark = leftMark + (rightMark-leftMark+1)
	rightMark = instr( leftMark, contents, "-" )
	LastM = trim(mid( contents, leftMark, (rightMark-leftMark)))

	leftMark = leftMark + (rightMark-leftMark+1)
	rightMark = instr( leftMark, contents, " " )
	LastD = trim(mid( contents, leftMark, (rightMark-leftMark)))

	leftMark = leftMark + (rightMark-leftMark+1)
	rightMark = instr( leftMark, contents, ":" )
	LastH = trim(mid( contents, leftMark, (rightMark-leftMark)))
	If LastH > 12 Then
		LastH = LastH -12
		AMPM = "PM"
	Else
		AMPM = "AM"
	End If

	leftMark = leftMark + (rightMark-leftMark+1)
	rightMark = instr( leftMark, contents, ":" )
	LastDay = trim(mid( contents, leftMark, (rightMark-leftMark)))

	leftMark = leftMark + (rightMark-leftMark+1)
	LastMin = trim(mid( contents, leftMark, 2))

	Get_Time = LastH & ":" & LastDay & ":" & LastMin & AMPM & " " & LastD & "." & LastM & "." & LastY
End Function

' Get the current usage HTML and write it to a file.
' Note: This function should only be called at intervals of AT LEAST 15 minutes.
Function Get_HTML
	Randomize
	sURL = "https://myaccount.optusnet.com.au/mydatamonitor/usage.txt?login=" & username & "&passwd=" & password & "&random=" & Rnd
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing

	Set fs = CreateObject("Scripting.FileSystemObject")
	Set f = fs.CreateTextFile("optususage.txt",true)
	f.write(ReturnHTML)
	f.close
	Set f = Nothing
	Set fs = Nothing
End Function

' Read the contents of the downloaded OptusNet information.
Function Read_File
	Dim contents
	Set fs = CreateObject ("Scripting.FileSystemObject")
	If (fs.FileExists("optususage.txt")) Then
		Set filePath = fs.GetFile("optususage.txt")
		Set File = filePath.OpenAsTextStream (1, -2)
		contents = file.readall
		File.Close
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else
		Get_HTML()
		Read_File()
	End If

	Read_File = contents
End Function

' returns number of days since plan started
Function DaysSince(theDate)
	contents = Read_File()

	leftMark = instr( contents, "start=" )
	leftMark = leftMark +6
	startday = trim(mid( contents, leftMark, 10))

	DaysSince = DateDiff("d", startday, Now)
End Function

' returns the days remaining for your billing period
Function DaysRemaining
	contents = Read_File()

	leftMark = instr( contents, "end=" )
	leftMark = leftMark +4
	monthSize = trim(mid( contents, leftMark, 10))

	Dim dateEnd, dateToday, dateSeconds

	dateEnd = monthsize
	dateSeconds = DateDiff("s", date, dateEnd)

	If (dateSeconds < 0) Then
		dateSeconds = 0
	End If

	DaysRemaining = Int(dateSeconds / 86400)
End Function

' returns the megabytes per day remaining until the end of your billing period
Function MBPerDayRemaining
	' subtract how many mb's are used so far from your total plan limit
	' and divide that value by the number of days remaining in your billing period

	MBPerDayRemaining = ((Get_PlanSize - Get_Usage) / DaysRemaining)
End Function